Subject: Re: [PATCH v3] ARM: smp: add support for per-task stack canaries

From: Kees Cook <[email-masked]>
Date: Wed, 11 Mar 2020 11:47:20 -0700

On Wed, Mar 11, 2020 at 11:31:13AM -0700, Guenter Roeck wrote:
> On 3/11/20 10:21 AM, Kees Cook wrote:
> > On Mon, Mar 09, 2020 at 09:49:31AM -0700, Guenter Roeck wrote:
> >> On Thu, Dec 06, 2018 at 09:32:57AM +0100, Ard Biesheuvel wrote:
> >>> On ARM, we currently only change the value of the stack canary when
> >>> switching tasks if the kernel was built for UP. On SMP kernels, this
> >>> is impossible since the stack canary value is obtained via a global
> >>> symbol reference, which means
> >>> a) all running tasks on all CPUs must use the same value
> >>> b) we can only modify the value when no kernel stack frames are live
> >>>    on any CPU, which is effectively never.
> >>>
> >>> So instead, use a GCC plugin to add a RTL pass that replaces each
> >>> reference to the address of the __stack_chk_guard symbol with an
> >>> expression that produces the address of the 'stack_canary' field
> >>> that is added to struct thread_info. This way, each task will use
> >>> its own randomized value.
> >>>
> >>> Cc: Russell King <[email-masked]>
> >>> Cc: Kees Cook <[email-masked]>
> >>> Cc: Emese Revfy <[email-masked]>
> >>> Cc: Arnd Bergmann <[email-masked]>
> >>> Cc: Laura Abbott <[email-masked]>
> >>> Cc: [email-masked]
> >>> Acked-by: Nicolas Pitre <[email-masked]>
> >>> Signed-off-by: Ard Biesheuvel <[email-masked]>
> >>
> >> Since this patch is in the tree, cc-option no longer works on
> >> the arm architecture if CONFIG_STACKPROTECTOR_PER_TASK is enabled.
> >>
> >> Any idea how to fix that ? 
> > 
> > I thought Arnd sent a patch to fix it and it got picked up?
> > 
> 
> Yes, but the fix is not upstream (it is only in -next), and I missed it.

Ah, yes, I found it again now too; it went through rmk's tree.

For thread posterity:

ARM: 8961/2: Fix Kbuild issue caused by per-task stack protector GCC plugin
https://www.arm.linux.org.uk/developer/patches/viewpatch.php?id=8961/2

-- 
Kees Cook

_______________________________________________
linux-arm-kernel mailing list
[email-masked]
http://lists.infradead.org/mailman/listinfo/linux-arm-kernel